<template lang="pug">
q-input.rounded-borders.ui-input-date(
	v-bind="{...$props, ...$attrs}",
	v-model="model",
	hide-bottom-space
	dense
	:lazy-rules="true"
	outlined
	:required="undefined"
	:label="label"
	:mask="mask"
	:rules="getRules"
	:hint="hint"
)
	template(#append)
		q-icon(name="event").cursor-pointer
			q-popup-proxy
				q-date(
					v-model="modelDate"
					:range="range"
					mask="DD.MM.YYYY"
				)
</template>

<script lang="ts" setup>
	import { defineProps, computed, defineEmits, ref } from 'vue'

	const props = defineProps({
		modelValue: String,
		from: String,
		to: String,
		type: {
			type: String,
			default: 'text',
		},
		label: {
			type: String,
			default: '',
		},
		required: {
			type: Boolean,
			default: false,
		},
		range: {
			type: Boolean,
			default: false,
		},
		rules: {
			type: Array,
			default: () => [],
		},
	})

	const hint = ref(props.range ? `Период в формате ДД.ММ.ГГГГ - ДД.ММ.ГГГГ` : `Дата в формате ДД.ММ.ГГГГ`)

	const mask = computed(() => {
		if (props.range) {
			return '##.##.#### - ##.##.####'
		} else {
			return '##.##.####'
		}
	})
	const emit = defineEmits(['update:modelValue', 'update:from', 'update:to'])
	const modelDate = computed({
		get() {
			if (props.range) {
				return {
					from: props.from,
					to: props.to,
				}
			} else {
				return props.modelValue
			}
		},
		set(value) {
			if (props.range) {
				emit('update:from', value.from)
				emit('update:to', value.to)
			} else {
				emit('update:modelValue', value)
			}
		},
	})
	const model = computed({
		get() {
			if (props.range) {
				return `${props.from} - ${props.to}`
			} else {
				return props.modelValue
			}
		},
		set(value: string) {
			if (props.range) {
				const date = value.split(' - ')
				emit('update:from', date[0])
				emit('update:to', date[1])
			} else {
				emit('update:modelValue', value)
			}
		},
	})
	const getRules = computed(() => {
		const dateReg =
			/^(?:(?:31(\/|-|\.)(?:0?[13578]|1[02]))\1|(?:(?:29|30)(\/|-|\.)(?:0?[13-9]|1[0-2])\2))(?:(?:1[6-9]|[2-9]\d)?\d{2})$|^(?:29(\/|-|\.)0?2\3(?:(?:(?:1[6-9]|[2-9]\d)?(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00))))$|^(?:0?[1-9]|1\d|2[0-8])(\/|-|\.)(?:(?:0?[1-9])|(?:1[0-2]))\4(?:(?:1[6-9]|[2-9]\d)?\d{2})$/gim
		let rules = []

		if (props.required) {
			rules.push((val: string) => val !== '' || `Необходимо указать ${props.label.toLowerCase()}`)
		}

		if (props.rules.length) {
			rules = [...rules, ...props.rules]
		}

		if (!!model.value) {
			rules.push((val: string) => {
				if (props.range) {
					const dates = val.split(' - ')
					return (
						(dateReg[Symbol.match](dates[0]) && dateReg[Symbol.match](dates[1])) ||
						'Проверьте корректность дат'
					)
				} else {
					return dateReg.test(val) || 'Проверьте корректность даты'
				}
			})
		}

		return props.rules.length || props.required ? rules : undefined
	})
</script>

<style lang="scss" scoped>
	.ui-input-date {
		&.q-field--focused,
		&.q-field--float {
			&:deep(.q-field__label) {
				transform: translateY(-85%) scale(0.75) !important;
				z-index: 1;
				background: $main-background;
				padding: 0 5px;
				margin-left: -5px;
				right: auto;
				max-width: calc(135% + 10px);
			}
		}

		&.q-textarea {
			&:deep(.q-field__control-container) {
				padding: 9px 0 7px !important;
			}
		}
	}
</style>
